using System;
using System.ServiceModel;
using System.ServiceModel.Web;

namespace WcfRestPox.Delicious
{
	[ServiceContract(Namespace = null)]
	[XmlSerializerFormat]
	interface IDeliciousService
	{
		[OperationContract]
		[WebGet(UriTemplate = "/v1/posts/update")]
		UpdateResponse GetLastUpdate();

		[OperationContract]
		[WebGet(UriTemplate = "/v1/tags/get")]
		TagsResponse GetAllTags();

		[OperationContract]
		[WebGet(UriTemplate = "/v1/tags/rename?old={old}&new={new}")]
		ResultResponse RenameTag(string old, string @new);
		
		[OperationContract]
		[WebGet(UriTemplate = "/v1/posts/get?tag={tag}&dt={dt}&url={url}")]
		PostsResponse GetPosts(string tag, DateTime? dt, string url);

		[OperationContract(Action = "/v1/posts/recent")]
		[WebGet(UriTemplate = "/v1/posts/recent?tag={tag}&count={count}")]
		PostsResponse GetRecentPosts(string tag, int? count);

		[OperationContract]
		[WebGet(UriTemplate = "/v1/posts/all?tag={tag}")]
		PostsResponse GetAllPosts(string tag);

		[OperationContract]
		[WebGet(UriTemplate = "/v1/posts/dates?tag={tag}")]
		DatesResponse GetDates(string tag);

		[OperationContract]
		[WebGet(UriTemplate = "/v1/posts/add?url={url}&description={description}&extended={extended}&tags={tags}")]
		ResultResponse AddPost(string url, string description, string extended, string[] tags);

		[OperationContract]
		[WebGet(UriTemplate = "/v1/posts/delete?url={url}")]
		ResultResponse DeletePost(string url);

		[OperationContract]
		[WebGet(UriTemplate = "/v1/tags/bundles/all")]
		BundlesResponse GetAllBundles();

		[OperationContract]
		[WebGet(UriTemplate = "/v1/tags/bundles/set?bundle={bundle}&tags={tags}")]
		ResultResponse SetBundle(string bundle, string[] tags);

		[OperationContract]
		[WebGet(UriTemplate = "/v1/tags/bundles/delete?bundle={bundle}")]
		ResultResponse DeleteBundle(string bundle);
	}
}
