﻿using System;
using System.ServiceModel.Dispatcher;

namespace WcfRestPox
{
	class DeliciousQueryStringConverter : QueryStringConverter
	{
		public override bool CanConvert(Type type)
		{
			if (type == typeof(DateTime?))
				return true;
			if (type == typeof(int?))
				return true;
			if (type == typeof(string[]))
				return true;

			return base.CanConvert(type);
		}

		public override string ConvertValueToString(object parameter, Type parameterType)
		{
			if (parameterType == typeof(DateTime?))
			{
				DateTime? dateTime = (DateTime?)parameter;
				if (dateTime.HasValue)
					return dateTime.Value.ToUniversalTime().ToString("o");
				else
					return string.Empty;
			}

			if (parameterType == typeof(int?))
			{
				int? value = (int?)parameter;
				if (value.HasValue)
					return value.Value.ToString();
				else
					return string.Empty;
			}

			if (parameterType == typeof(string[]))
			{
				if (parameter == null)
					return string.Empty;
				return string.Join(" ", ((string[])parameter));
			}

			return base.ConvertValueToString(parameter, parameterType);
		}
	}
}
